from toee import *

def OnBeginSpellCast( spell ):
	print "Order's Wrath OnBeginSpellCast"
	print "spell.target_list=", spell.target_list
	print "spell.caster=", spell.caster, " caster.level= ", spell.caster_level
	game.particles( "sp-evocation-conjure", spell.caster )

def OnSpellEffect( spell ):
	print "Order's Wrath OnSpellEffect"

	remove_list = []

	damage_dice = dice_new( '1d8' )
	if ( spell.caster_level >= 10 ):
		damage_dice.number = 5
	elif ( spell.caster_level >= 8 ):
		damage_dice.number = 4
	elif ( spell.caster_level >= 6 ):
		damage_dice.number = 3
	elif ( spell.caster_level >= 4 ):
		damage_dice.number = 2
	else:
		damage_dice.number = 1

	spell.duration = 1

	game.particles( 'sp-Orders Wrath', spell.target_loc )

	for target_item in spell.target_list:

		# check if target is CHAOTIC
		alignment = target_item.obj.critter_get_alignment()
		if (alignment & ALIGNMENT_CHAOTIC) or ( (alignment & ALIGNMENT_CHAOTIC) and not (alignment & ALIGNMENT_LAWFUL) ):

			# allow Reflex saving throw for half
			if target_item.obj.saving_throw_spell( spell.dc, D20_Save_Reflex, D20STD_F_NONE, spell.caster, spell.id ):
	
				# saving throw succesful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30001 )
	
				# half damage
				target_item.obj.spell_damage_with_reduction( spell.caster, D20DT_UNSPECIFIED, damage_dice, D20DAP_UNSPECIFIED, DAMAGE_REDUCTION_HALF, D20A_CAST_SPELL, spell.id )
	
				remove_list.append( target_item.obj )
	
			else:
				# saving throw unsuccesful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30002 )
	
				# full damage
				target_item.obj.spell_damage( spell.caster, D20DT_UNSPECIFIED, damage_dice, D20DAP_UNSPECIFIED, D20A_CAST_SPELL, spell.id )
	
				# daze the victim
				target_item.obj.condition_add_with_args( 'sp-Orders Wrath', spell.id, spell.duration, 0 )

		elif not (alignment & ALIGNMENT_LAWFUL) and not (alignment & ALIGNMENT_CHAOTIC):

			remove_list.append( target_item.obj )

			# allow Reflex saving throw for quarter
			if target_item.obj.saving_throw_spell( spell.dc, D20_Save_Reflex, D20STD_F_NONE, spell.caster, spell.id ):
	
				# saving throw succesful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30001 )
	
				# quarter damage
				target_item.obj.spell_damage_with_reduction( spell.caster, D20DT_UNSPECIFIED, damage_dice, D20DAP_UNSPECIFIED, DAMAGE_REDUCTION_QUARTER, D20A_CAST_SPELL, spell.id )
	
			else:
				# saving throw unsuccesful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30002 )
	
				# half damage
				target_item.obj.spell_damage_with_reduction( spell.caster, D20DT_UNSPECIFIED, damage_dice, D20DAP_UNSPECIFIED, DAMAGE_REDUCTION_HALF, D20A_CAST_SPELL, spell.id )
	
				# do NOT stagger the victim
				#target_item.obj.condition_add_with_args( 'sp-Orders Wrath', spell.id, spell.duration, 0 )

		else:

			game.particles( 'Fizzle', target_item.obj )
			remove_list.append( target_item.obj )

	spell.target_list.remove_list( remove_list )
	spell.spell_end( spell.id )

def OnBeginRound( spell ):
	print "Order's Wrath OnBeginRound"

def OnEndSpellCast( spell ):
	print "Order's Wrath OnEndSpellCast"