from toee import *
from utilities import *

def san_dialog( attachee, triggerer ):
	game.global_flags[70] = 1
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		triggerer.begin_dialog( attachee, 350 )
	elif ((triggerer.item_find(2202) != OBJ_HANDLE_NULL) or (triggerer.item_find(3008) != OBJ_HANDLE_NULL)):
		triggerer.begin_dialog( attachee, 330 )
	elif ((game.quests[32].state == qs_completed) and (game.global_flags[74] == 0)):
		triggerer.begin_dialog( attachee, 270 )
	elif (game.quests[31].state == qs_completed):
		triggerer.begin_dialog( attachee, 200 )
	elif (game.global_flags[73] == 1):
		triggerer.begin_dialog( attachee, 120 )
	else:
		triggerer.begin_dialog( attachee, 1 )
	return SKIP_DEFAULT


def san_enter_combat( attachee, triggerer ):
	if (triggerer.type == obj_t_pc):
		leader = attachee.leader_get()
		if (leader != OBJ_HANDLE_NULL):
			leader.follower_remove(attachee)
		elmo = find_npc_near( attachee, 8000)
		if (elmo != OBJ_HANDLE_NULL):
			attachee.float_line(380,triggerer)
			leader = elmo.leader_get()
			if (leader != OBJ_HANDLE_NULL):
				leader.follower_remove(elmo)
			elmo.attack(triggerer)
	return RUN_DEFAULT		
		

def san_heartbeat( attachee, triggerer ):
	if (not game.combat_is_active()):
		if (game.global_flags[362] == 0):
			for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
				if (is_safe_to_talk(attachee,obj)):
					if ((obj.item_find(2202) != OBJ_HANDLE_NULL) or (obj.item_find(3008) != OBJ_HANDLE_NULL)):
						obj.begin_dialog(attachee,330)
						game.global_flags[362] = 1
						return RUN_DEFAULT
		if (game.global_flags[72] == 0):
			for obj in game.obj_list_vicinity(attachee.location,OLC_NPC):
				if (obj.name == 8000):
					if (is_safe_to_talk(attachee,obj)):
						leader = obj.leader_get()
						if (leader == OBJ_HANDLE_NULL):
							leader = attachee.leader_get()
						if (leader != OBJ_HANDLE_NULL):
							leader.begin_dialog(attachee,400)	
							return RUN_DEFAULT
		if (game.global_flags[366] == 1):
			leader = attachee.leader_get()
			if (leader != OBJ_HANDLE_NULL):
				attachee.turn_towards(leader)
				attachee.float_line(12023,leader)
				leader.follower_remove(attachee)
				attachee.attack(leader)
				game.global_flags[366] = 0
				return RUN_DEFAULT
		if (game.global_flags[367] == 1):
			leader = attachee.leader_get()
			if (leader != OBJ_HANDLE_NULL):
				attachee.turn_towards(leader)
				attachee.float_line(10014,leader)
				leader.follower_remove(attachee)
				game.global_flags[367] = 0
				return RUN_DEFAULT
	return RUN_DEFAULT

def san_join( attachee, triggerer ):
	for chest in game.obj_list_vicinity(attachee.location,OLC_CONTAINER):
		if (chest.name == 1202):
			chest.item_transfer_to( attachee, 2202 )
			chest.item_transfer_to( attachee, 3008 )
			attachee.item_wield_best_all()
			return RUN_DEFAULT
	return RUN_DEFAULT

def san_disband( attachee, triggerer ):
	for obj in triggerer.group_list():
		if (obj.name == 8021):
			triggerer.follower_remove(obj)
		if (obj.name == 8022):
			triggerer.follower_remove(obj)
	return RUN_DEFAULT

def make_elmo_talk( attachee, triggerer, line):
	npc = find_npc_near(attachee,8000)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,410)
	return SKIP_DEFAULT

def talk_to_screng( attachee, triggerer, line):
	npc = find_npc_near(attachee,8021)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,470)
	return SKIP_DEFAULT

def switch_to_thrommel( attachee, triggerer):
	npc = find_npc_near(attachee,8031)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,40)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,510)
	return SKIP_DEFAULT

def san_new_map( attachee, triggerer ):
	if ((attachee.map == 5066) or (attachee.map == 5067) or (attachee.map == 5078) or (attachee.map == 5079) or (attachee.map == 5080)):
		game.global_flags[73] = 1
		if (game.quests[31].state == qs_accepted):
			game.quests[31].state = qs_completed
	elif ((attachee.map == 5062) or (attachee.map == 5113) or (attachee.map == 5093)):
		game.global_flags[73] = 1
		leader = attachee.leader_get()
		if (leader != OBJ_HANDLE_NULL):
			if ((leader.stat_level_get(stat_alignment) == LAWFUL_EVIL) or (leader.stat_level_get(stat_alignment) == CHAOTIC_EVIL) or (leader.stat_level_get(stat_alignment) == NEUTRAL_EVIL)):
				percent = group_percent_hp(leader)
				if ((percent < 30) or (game.global_flags[74] == 1)):
					game.global_flags[366] = 1
	elif (attachee.map == 5051):
		if (((game.global_flags[73] == 1) and (game.quests[31].state == qs_unknown)) or (game.quests[31].state == qs_completed)):
			leader = attachee.leader_get()
			if (leader != OBJ_HANDLE_NULL):
				game.global_flags[367] = 1
	return RUN_DEFAULT